#include "NesScreenWidget.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "InfoNES_System.h"
#include "InfoNES.h"
#include "InfoNES_pAPU.h"

#include <QMutexLocker>
#include <QPainter>
#include <QPoint>
#include <QThread>
#include <QDebug>

#define lcd_width 512
#define lcd_height 480

WORD WorkFrameX[lcd_width * lcd_height];
NesScreenWidget::NesScreenWidget(QWidget *parent) : QWidget(parent), isGray(false)
{
    make_zoom_tab();
    image = QImage((uchar *)WorkFrame, NES_DISP_WIDTH, NES_DISP_HEIGHT, QImage::Format_RGB555);
    image1 = QImage((uchar *)WorkFrameX, lcd_width, lcd_height, QImage::Format_RGB555);
    timer.start(1000 / 24, this);
}

NesScreenWidget::~NesScreenWidget()
{
}

void NesScreenWidget::timerEvent(QTimerEvent *event)
{
    InfoNES_LoadFrame();
    update();
}

void NesScreenWidget::resizeEvent(QResizeEvent *event)
{
    qDebug() << "resize width:" << width() << " height:" << height();
}

void NesScreenWidget::paintEvent(QPaintEvent *event)
{
    QPainter painter;
    painter.begin(this);
    painter.drawImage(QPoint(0, 0), image1);
    painter.end();
}

static int *zoom_x_tab;
static int *zoom_y_tab;
static int *lcd_w_y;
static int *zoom_y_tab_NES_DISP_WIDTH;
int NesScreenWidget::make_zoom_tab()
{
    int i;
    zoom_x_tab = (int *)malloc(sizeof(int) * lcd_width);

    if (NULL == zoom_x_tab)
    {
        printf("make zoom_x_tab error\n");
        return -1;
    }
    for (i = 0; i < lcd_width; i++)
    {
        zoom_x_tab[i] = i * NES_DISP_WIDTH / lcd_width;
    }
    zoom_y_tab = (int *)malloc(sizeof(int) * lcd_height);
    if (NULL == zoom_y_tab)
    {
        printf("make zoom_y_tab error\n");
        return -1;
    }
    for (i = 0; i < lcd_height; i++)
    {
        zoom_y_tab[i] = i * NES_DISP_HEIGHT / lcd_height;
    }

    lcd_w_y = (int *)malloc(sizeof(int) * lcd_height); // lcd_width*(1----lcd_height)
    if (NULL == lcd_w_y)
    {
        printf("lcd_width mul 1 up lcd_height error\n");
        return -1;
    }
    for (i = 0; i < lcd_height; i++)
    {
        lcd_w_y[i] = lcd_width * i;
    }
    zoom_y_tab_NES_DISP_WIDTH = (int *)malloc(sizeof(int) * lcd_height); // zoom_y_tab[y] * NES_DISP_WIDTH;
    if (NULL == zoom_y_tab_NES_DISP_WIDTH)
    {
        printf("zoom_y_tab[y] * NES_DISP_WIDTH error\n");
        return -1;
    }
    for (i = 0; i < lcd_height; i++)
    {
        zoom_y_tab_NES_DISP_WIDTH[i] = zoom_y_tab[i] * NES_DISP_WIDTH;
    }
    return 1;
}
void NesScreenWidget::InfoNES_LoadFrame()
{
    int x, y;
    int line_width;
    for (y = 0; y < lcd_height; y++)
    {
        line_width = *(zoom_y_tab_NES_DISP_WIDTH + y);
        for (x = 0; x < lcd_width; x++)
        {
            *(WorkFrameX + (lcd_w_y[y]) + x) = *(WorkFrame + line_width + zoom_x_tab[x]);
        }
    }
}

void NesScreenWidget::loadFrame()
{
}
